"""
    ai/h2o/engine/v1/adjusted_dai_profile.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: version not set
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from h2o_engine_manager.gen.api_client import ApiClient, Endpoint as _Endpoint
from h2o_engine_manager.gen.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from h2o_engine_manager.gen.model.dai_setup_resource import DAISetupResource
from h2o_engine_manager.gen.model.rpc_status import RpcStatus
from h2o_engine_manager.gen.model.v1_get_dai_setup_response import V1GetDAISetupResponse
from h2o_engine_manager.gen.model.v1_update_dai_setup_response import V1UpdateDAISetupResponse


class DAISetupServiceApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.d_ai_setup_service_get_dai_setup_endpoint = _Endpoint(
            settings={
                'response_type': (V1GetDAISetupResponse,),
                'auth': [],
                'endpoint_path': '/v1/{name_4}',
                'operation_id': 'd_ai_setup_service_get_dai_setup',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'name_4',
                ],
                'required': [
                    'name_4',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'name_4',
                ]
            },
            root_map={
                'validations': {
                    ('name_4',): {

                        'regex': {
                            'pattern': r'workspaces\/[^\/]+\/daiSetup',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'name_4':
                        (str,),
                },
                'attribute_map': {
                    'name_4': 'name_4',
                },
                'location_map': {
                    'name_4': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.d_ai_setup_service_update_dai_setup_endpoint = _Endpoint(
            settings={
                'response_type': (V1UpdateDAISetupResponse,),
                'auth': [],
                'endpoint_path': '/v1/{daiSetup.name}',
                'operation_id': 'd_ai_setup_service_update_dai_setup',
                'http_method': 'PATCH',
                'servers': None,
            },
            params_map={
                'all': [
                    'dai_setup_name',
                    'update_mask',
                    'dai_setup',
                ],
                'required': [
                    'dai_setup_name',
                    'update_mask',
                    'dai_setup',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'dai_setup_name',
                ]
            },
            root_map={
                'validations': {
                    ('dai_setup_name',): {

                        'regex': {
                            'pattern': r'workspaces\/[^\/]+\/daiSetup',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'dai_setup_name':
                        (str,),
                    'update_mask':
                        (str,),
                    'dai_setup':
                        (DAISetupResource,),
                },
                'attribute_map': {
                    'dai_setup_name': 'daiSetup.name',
                    'update_mask': 'updateMask',
                },
                'location_map': {
                    'dai_setup_name': 'path',
                    'update_mask': 'query',
                    'dai_setup': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def d_ai_setup_service_get_dai_setup(
        self,
        name_4,
        **kwargs
    ):
        """Returns a DAISetup from a workspace.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.d_ai_setup_service_get_dai_setup(name_4, async_req=True)
        >>> result = thread.get()

        Args:
            name_4 (str): DAISetup resource name. Format: workspaces/{workspace}/daiSetup

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            V1GetDAISetupResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['name_4'] = \
            name_4
        return self.d_ai_setup_service_get_dai_setup_endpoint.call_with_http_info(**kwargs)

    def d_ai_setup_service_update_dai_setup(
        self,
        dai_setup_name,
        update_mask,
        dai_setup,
        **kwargs
    ):
        """Updates a DAISetup.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.d_ai_setup_service_update_dai_setup(dai_setup_name, update_mask, dai_setup, async_req=True)
        >>> result = thread.get()

        Args:
            dai_setup_name (str): DAISetup resource name.
            update_mask (str): The list of paths referencing which fields to update. Update mask must be non-empty.  Allowed field paths are: {cpu_constraint, gpu_constraint, memory_bytes_constraint, storage_bytes_constraint, max_idle_duration_constraint, max_running_duration_constraint, max_non_interaction_duration, max_unused_duration, configuration_override, yaml_pod_template_spec, yaml_gpu_tolerations, triton_enabled}  To update all allowed fields, specify exactly one path with value \"*\".
            dai_setup (DAISetupResource): DAISetup resource.

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            V1UpdateDAISetupResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['dai_setup_name'] = \
            dai_setup_name
        kwargs['update_mask'] = \
            update_mask
        kwargs['dai_setup'] = \
            dai_setup
        return self.d_ai_setup_service_update_dai_setup_endpoint.call_with_http_info(**kwargs)

